Last Comment Bug 807629 - Appmenu stays open after menu item selection
: Appmenu stays open after menu item selection
Status: RESOLVED FIXED
: regression
Product: Thunderbird
Classification: Client Software
Component: Toolbars and Tabs (show other bugs)
: Trunk
: x86_64 Windows 7
: -- normal (vote)
: Thunderbird 19.0
Assigned To: Philipp Kewisch [:Fallen]
: Mike Conley (:mconley) - (Needinfo me!)
Mentors:
Depends on:
Blocks: 785692
  Show dependency treegraph
 
Reported: 2012-11-01 06:16 PDT by Sean Smith
Modified: 2012-11-12 04:16 PST (History)
6 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
+
fixed
+
fixed
fixed


Attachments
Fix - v1 (1.47 KB, patch)
2012-11-02 10:58 PDT, Philipp Kewisch [:Fallen]
mconley: review+
standard8: approval‑comm‑aurora+
standard8: approval‑comm‑beta+
Details | Diff | Splinter Review

Description Sean Smith 2012-11-01 06:16:49 PDT
User Agent: Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; Zune 4.7)

Steps to reproduce:

Mozilla/5.0 (Windows NT 6.1; WOW64; rv:19.0) Gecko/19.0 Thunderbird/19.0a1 (01 November 2012 build)

When you open the appmenu, and then choose one of the menu items, the action is completed, and the menu stays open.


Actual results:

I selected the menu item Options... and the options dialog opened.  When I closed the options dialog, the appmenu opened again.

When I selected the New Message menu item, the compose window opened, but the appmenu remained open.


Expected results:

The appmenu should not reopen after dismissing the options dialog or after choosing any other menu item.
Comment 1 Ludovic Hirlimann [:Usul] 2012-11-01 06:38:28 PDT
This might be by design?
Comment 2 Alice0775 White 2012-11-01 07:47:44 PDT
Regression window
Good:
http://hg.mozilla.org/mozilla-central/rev/9d285bedbc1f
http://hg.mozilla.org/comm-central/rev/2aee2804b79b
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:18.0) Gecko/18.0 Thunderbird/18.0a1 ID:20120923030232
Bad:
http://hg.mozilla.org/mozilla-central/rev/faa753e8601f
http://hg.mozilla.org/comm-central/rev/987cb8d53150
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:18.0) Gecko/18.0 Thunderbird/18.0a1 ID:20120924043558
Pushlog:
http://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=9d285bedbc1f&tochange=faa753e8601f
http://hg.mozilla.org/comm-central/pushloghtml?fromchange=2aee2804b79b&tochange=987cb8d53150

Suspected : Bug 785692
Comment 3 Alice0775 White 2012-11-01 08:00:28 PDT
This also affected in 17beta and maybe affected 17esr.

http://hg.mozilla.org/releases/mozilla-beta/rev/2584cac54ea7
http://hg.mozilla.org/releases/comm-beta/rev/f5fbdcff1f78
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:17.0) Gecko/17.0 Thunderbird/17.0 ID:20121030125442
Comment 4 Mike Conley (:mconley) - (Needinfo me!) 2012-11-01 08:30:32 PDT
Just reproduced this on Windows 7. On OSX and Ubuntu, I notice that after I click, the menu respawns before hiding - so I think it's a race.

STR:

1) On a Windows machine, click on the AppMenu, and choose "Options"
2) When the Options dialog appears, click "Cancel" to close it.

What happens?

The AppMenu respawns.

What's expected?

The AppMenu should not respawn.
Comment 5 Mike Conley (:mconley) - (Needinfo me!) 2012-11-01 08:32:59 PDT
Hm - this seems to happen on each of our split menus - so I see it on Print, Message Filters, Find, and New Message.
Comment 6 Mike Conley (:mconley) - (Needinfo me!) 2012-11-01 08:58:52 PDT
I think I've traced this to our appmenu-vertical binding here:

http://mxr.mozilla.org/comm-central/source/mail/base/content/mailWidgets.xml#2832

Since the menupopup exists *within* the button, I think the click handler is called both when we first open the menu, and (it seems) any time we click on a splitmenu immediately beneath the menupopup.

Philipp - I do believe you introduced this binding. Any ideas what we can do about this?
Comment 7 Philipp Kewisch [:Fallen] 2012-11-02 10:58:37 PDT
Created attachment 677822 [details] [diff] [review]
Fix - v1

This should take care, tested on Mac.
Comment 8 Mike Conley (:mconley) - (Needinfo me!) 2012-11-02 14:18:13 PDT
Comment on attachment 677822 [details] [diff] [review]
Fix - v1

Review of attachment 677822 [details] [diff] [review]:
-----------------------------------------------------------------

Yep - looks great! Thanks Phillip!
Comment 9 Philipp Kewisch [:Fallen] 2012-11-03 00:49:08 PDT
https://hg.mozilla.org/comm-central/rev/c42bb5c1cfd0
Comment 10 Sean Smith 2012-11-03 07:23:40 PDT
Confirming as fixed for me.  Thanks!

Mozilla/5.0 (Windows NT 6.1; rv:19.0) Gecko/19.0 Thunderbird/19.0a1 (03 November 2012 build)

Note You need to log in before you can comment on or make changes to this bug.